"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var $ = require("jquery");
var ProjectWindows = /** @class */ (function () {
    function ProjectWindows(containerdiv, project) {
        this.id2window = {};
        this.id2createfn = {};
        this.id2div = {};
        this.containerdiv = containerdiv;
        this.project = project;
    }
    // TODO: delete windows ever?
    ProjectWindows.prototype.setCreateFunc = function (id, createfn) {
        this.id2createfn[id] = createfn;
    };
    ProjectWindows.prototype.createOrShow = function (id) {
        var wnd = this.id2window[id];
        if (!wnd) {
            wnd = this.id2window[id] = this.id2createfn[id](id);
        }
        var div = this.id2div[id];
        if (!div) {
            var data = this.project.getFile(id) + ""; // TODO: binary files
            div = this.id2div[id] = wnd.createDiv(this.containerdiv, data);
        }
        if (this.activewnd != wnd) {
            if (this.activediv)
                $(this.activediv).hide();
            this.activediv = div;
            this.activewnd = wnd;
            $(div).show();
            this.refresh(true);
            this.refreshErrors();
        }
        this.activeid = id;
        return wnd;
    };
    ProjectWindows.prototype.put = function (id, window) {
        this.id2window[id] = window;
    };
    ProjectWindows.prototype.refresh = function (moveCursor) {
        // refresh current window
        if (this.activewnd && this.activewnd.refresh)
            this.activewnd.refresh(moveCursor);
    };
    ProjectWindows.prototype.tick = function () {
        if (this.activewnd && this.activewnd.tick)
            this.activewnd.tick();
    };
    ProjectWindows.prototype.setErrors = function (errors) {
        this.lasterrors = errors;
        this.refreshErrors();
    };
    ProjectWindows.prototype.refreshErrors = function () {
        if (this.activewnd && this.activewnd.markErrors) {
            if (this.lasterrors && this.lasterrors.length)
                this.activewnd.markErrors(this.lasterrors);
            else
                this.activewnd.clearErrors();
        }
    };
    ProjectWindows.prototype.getActive = function () { return this.activewnd; };
    ProjectWindows.prototype.getActiveID = function () { return this.activeid; };
    ProjectWindows.prototype.getCurrentText = function () {
        if (this.activewnd && this.activewnd.getValue)
            return this.activewnd.getValue();
        else
            alert("Please switch to an editor window.");
    };
    return ProjectWindows;
}());
exports.ProjectWindows = ProjectWindows;
;
//# sourceMappingURL=windows.js.map