"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SourceFile = /** @class */ (function () {
    function SourceFile(lines, text) {
        lines = lines || [];
        this.lines = lines;
        this.text = text;
        this.offset2line = {};
        this.line2offset = {};
        for (var _i = 0, lines_1 = lines; _i < lines_1.length; _i++) {
            var info = lines_1[_i];
            if (info.offset >= 0) {
                this.offset2line[info.offset] = info.line;
                this.line2offset[info.line] = info.offset;
            }
        }
    }
    SourceFile.prototype.findLineForOffset = function (PC, lookbehind) {
        if (this.offset2line) {
            for (var i = 0; i <= lookbehind; i++) {
                var line = this.offset2line[PC];
                if (line >= 0) {
                    return line;
                }
                PC--;
            }
        }
        return null;
    };
    SourceFile.prototype.lineCount = function () { return this.lines.length; };
    return SourceFile;
}());
exports.SourceFile = SourceFile;
;
;
//# sourceMappingURL=workertypes.js.map